#ifndef __c2_uvms_h__
#define __c2_uvms_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c2_ResolvedFunctionInfo;

#ifndef struct_slBus1_tag
#define struct_slBus1_tag

typedef struct slBus1_tag
{
  real_T a[6];
  real_T d[6];
  real_T alpha[6];
} c2_slBus1;

#else

typedef struct slBus1_tag c2_slBus1;

#endif

#ifndef struct_slBus2_tag
#define struct_slBus2_tag

typedef struct slBus2_tag
{
  real_T g0b[9];
  real_T g0i[96];
  real_T R0i[54];
  real_T p0i[18];
  real_T Adg0i[216];
  real_T Adg0i_inv[216];
  real_T gbi[96];
  real_T Rbi[54];
  real_T pbi[18];
  real_T Adgbi[216];
  real_T Adgbi_inv[216];
  real_T g6e[16];
  real_T g0e[16];
  real_T R0e[9];
  real_T p0e[3];
  real_T Adg0e[36];
  real_T Adg0e_inv[36];
  real_T gbe[16];
  real_T Rbe[9];
  real_T pbe[3];
  real_T Adgbe[36];
  real_T Adgbe_inv[36];
} c2_slBus2;

#else

typedef struct slBus2_tag c2_slBus2;

#endif

typedef struct {
  int32_T c2_sfEvent;
  boolean_T c2_isStable;
  boolean_T c2_doneDoubleBufferReInit;
  uint8_T c2_is_active_c2_uvms;
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T *c2_counter_address;
  int32_T c2_counter_index;
} SFc2_uvmsInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c2_uvms_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c2_uvms_get_check_sum(mxArray *plhs[]);
extern void c2_uvms_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
